open(IN,"embl/rfam_embl_seqs.all");
while(<IN>){
  chomp $_; @s=split(/\s+/,$_);
  $seqs{$s[0]}=$s[1];
}
close IN;
printf("done reading embl\n");

opendir(DIR,"RNA-genome-only-divergent");
while($f = readdir(DIR)){
  if($f !~ /flankunaligned/){ next; }
  open(IN,"RNA-genome-only-divergent/$f");
  $n0=<IN>; $s0=<IN>; $n1=<IN>; $s1=<IN>; close IN;
  chomp $s0; chomp $s1; chomp $n0; chomp $n1;
  if(length($s0) > length($s1)){ $short=$s1; $sn=$n1; $long=$s0; $ln=$n0; } 
  else { $short=$s0; $sn=$n0; $long=$s1; $ln=$n1; }

  $sn=~s/\>//g; $ln=~s/\>//g;
  if($sn =~ /\./) { @s=split(/\./,$sn); $sn=$s[0]; }
  if( !exists($seqs{$sn}) ){print "$sn not found for dataset $f!\n"; next; }

  $genseq=$seqs{$sn}; 
  $revshort=&rev_comp($short);
  if(index($genseq,$short) == -1 && index($genseq,$revshort) == -1 ) {
    print "short not found in genomic seq for $f!\n"; next; 
  }

  if(index($genseq,$revshort) != -1) { $genseq=&rev_comp($genseq);}

#  print "$sn, $genseq, $short\n";
  $st=index($genseq,$short); 
  if($st == -1) { print "how could this be for $f?!\n"; next; }
  $left=substr($genseq,0,$st);
  $right=substr($genseq,$st+length($short));
#  if(length($left)>7500){$left=substr($left,length($left)-7500);}
#  if(length($right)>7500){$right=substr($right,0,7500);}
  if(length($left)>150){$left=substr($left,length($left)-150);}
  if(length($right)>150){$right=substr($right,0,150);}
  $newgen=uc($left).$short.uc($right);

  $data=$f; $data=~s/\.flankunaligned//g; 
  open(OUT, ">RNA-genome-flank2-divergent/$data.gengen6");
  printf OUT ">%s\n%s\n>%s\n%s\n", $sn, $newgen, $ln, $long; 
  close OUT;
  
  $st=index($newgen,$short);
  open(OUT, ">RNA-genome-flank2-divergent/$data.query_startend6");
  printf OUT "%d %d", $st, ($st+length($short))-1; 
  close OUT;
#  last;
}
  
sub rev_comp {
  $seq=$_[0];
  $map{'A'}='T';
  $map{'C'}='G';
  $map{'G'}='C';
  $map{'T'}='A';
  $seq=reverse($seq);
  $rseq="";
  for(my $i=0;$i<length($seq);$i++){
    $rseq .= $map{substr($seq,$i,1)};
  }
  return $rseq;
}
